from stumpf.tama import ChibiTama, listen


class ExampleTama(ChibiTama):
    @listen('foo')
    def do_a_foo(self, channel, msg):
        self.log.info(f'I recieved a "foo" message with "{msg}" as arguments')

    @listen('derp')
    def do_a_derp(self, channel, msg):
        self.log.info(f'I recieved a "derp" message with "{msg}" as arguments')

    @listen('blowup')
    def do_an_exception(self, channel, msg):
        raise RuntimeError('Intentionally busted!')


class ExampleTama2(ChibiTama):
    """A second example pipeline.

    This pipeline is connected to several channels including 'foo',
    and 'bar'.

    """
    @listen('foo', 'baz')
    def do_a_foo(self, channel, msg):
        self.log.info(f'I recieved a "{channel}" message with "{msg}" '
                      'as arguments and am executing do_a_foo method')

    @listen('bar')
    @listen('foo')
    @listen('derp')
    def do_a_derp(self, channel, msg):
        self.log.info(f'I recieved a "{channel}" message with "{msg}" '
                      'as arguments and am executing do_a_derp method')
